{% load static %}
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Django Celery Progress Sample</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css"
        integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
</head>

<body>
    {% comment %} {% include "navbar.html" %} {% endcomment %}

    <div class="container-fluid">
        <div class="row mt-5">
            <div class="col-md-6 offset-md-3 col-lg-6 offset-lg-3 sm-12 mb-5">
                <div class="card bg-light">
                    <div class="card-body">
                        <h5 class="card-title">Import user from excel</h5>
                        <div class="row">
                            <div class="col-md-12 mb-3">
                                <form id="form-import" method="POST" action="{% url 'core:import' %}"
                                    enctype="multipart/form-data">
                                    {% csrf_token %}
                                    <div class="form-inline">
                                        <input type="file" name="document_file" class="form-control col mr-2" required>
                                        <button type="submit" class="btn btn-primary">Import</button>
                                    </div>
                                </form>
                            </div>
                            <div id="import-progress-container" class="col-md-12">
                                <div id="import-progress-message">Waiting event . . .</div>
                                <div class="progress">
                                    <div id="import-progress-bar"
                                        class="progress-bar progress-bar-striped progress-bar-animated"
                                        role="progressbar" aria-valuemin="0" aria-valuemax="100">
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <script src="https://code.jquery.com/jquery-3.5.1.min.js"
        integrity="sha256-9/aliU8dGd2tb6OSsuzixeV4y/faTqgFtohetphbbj0=" crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js"
        integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q"
        crossorigin="anonymous"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js"
        integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl"
        crossorigin="anonymous"></script>
    <script src="{% static 'celery_progress/celery_progress.js' %}"></script>
    <script>
        $(function () {
            $("#form-import").on("submit", (e) => {
                e.preventDefault()
                let formData = new FormData($("#form-import")[0])
                {% comment %} formData.append("csrfmiddlewaretoken", "{% csrf_token %}") {% endcomment %}
                $.ajax({
                    type: "POST",
                    url: "{% url 'core:import' %}",
                    data: formData,
                    contentType: false,
                    processData: false,
                    cache: false,
                    async: true,
                    success: function (res) {
                        getProgress(
                            res.task_id,
                            progressBarId = "import-progress-bar",
                            progressBarMessageId = "import-progress-message"
                        )
                    },
                    error: function (err) {
                        console.log(err);
                    },
                })
            })

            getProgress = (taskId, progressBarId, progressBarMessageId) => {
                var progressUrl = `{% url 'core:progress' %}?task_id=${taskId}`;
                function onExportUserProgress(progressBarElement, progressBarMessageElement, progress) {
                    progressBarMessageElement.innerHTML = `Progress ${progress.percent}% . . .`
                    progressBarElement.setAttribute("style", `width: ${progress.percent}%`)
                    progressBarElement.setAttribute("aria-valuenow", progress.percent)
                }

                function onExportUserSuccess(progressBarElement, progressBarMessageElement, result) {
                    alert("Complete progress 100%")
                    progressBarMessageElement.innerHTML = "Waiting event . . ."
                    progressBarElement.setAttribute("style", "width: 0%")
                    progressBarElement.setAttribute("aria-valuenow", 0)
                }
                CeleryProgressBar.initProgressBar(progressUrl, {
                    progressBarId: progressBarId,
                    progressBarMessageId: progressBarMessageId,
                    onProgress: onExportUserProgress,
                    onSuccess: onExportUserSuccess,
                })
            }
        });
    </script>
</body>

</html>